import { markHTMLString } from "./escape.js";
const animations = {
  "slide": {
    old: "--astro-animate-old-slideout",
    new: "--astro-animate-new-slidein",
    backOld: "--astro-animate-back-old-slideout-names",
    backNew: "--astro-animate-back-new-slideout-names"
  },
  "fade": {
    old: "--astro-animate-old-fade",
    new: "--astro-animate-new-fade"
  }
};
const transitionNameMap = /* @__PURE__ */ new WeakMap();
function incrementTransitionNumber(result) {
  let num = 1;
  if (transitionNameMap.has(result)) {
    num = transitionNameMap.get(result) + 1;
  }
  transitionNameMap.set(result, num);
  return num;
}
function createTransitionScope(result, hash) {
  const num = incrementTransitionNumber(result);
  return `astro-${hash}-${num}`;
}
function renderTransition(result, hash, animationName, transitionName) {
  if (!animationName) {
    animationName = "morph";
  }
  const animation = animations[animationName];
  const scope = createTransitionScope(result, hash);
  if (!transitionName) {
    transitionName = scope;
  }
  const styles = markHTMLString(`<style>[data-astro-transition-scope="${scope}"] {
		view-transition-name: ${transitionName};
	}
	${animationName === "morph" ? "" : `
	::view-transition-old(${transitionName}) {
		animation: var(${animation.old});
	}
	::view-transition-new(${transitionName}) {
		animation: var(${animation.new});
	}
	
	${"backOld" in animation && "backNew" in animation ? `
	.astro-back-transition::view-transition-old(${transitionName}) {
		animation-name: var(${animation.backOld});
	}
	.astro-back-transition::view-transition-new(${transitionName}) {
		animation-name: var(${animation.backNew});
	}
	`.trim() : ""}
	
	`.trim()}
	</style>`);
  result.extraHead.push(styles);
  return scope;
}
export {
  renderTransition
};
